VARS    EQU #5E80

        ORG #9900
        LD HL,TFNF
        LD DE,TFNE
        CALL #8123
        JR NZ,LEN0
        PUSH HL
        POP IY
        LD A,(IY+13)
        CP 8
        JR NZ,LEN0
        LD A,(IX-96)
        PUSH AF
        LD (IX-96),4
        LD HL,FONT64
        LD D,(IY+15)
        LD E,(IY+14)
        LD B,8
        CALL #80AB
        POP AF
        LD (IX-96),A
LEN0    CALL #8069
        PUSH HL
        POP IY
        LD A,(IY+13)
        AND A
        RET Z
        LD BC,#1418
        CALL #80D8
        LD A,32
        RST 16
        LD D,(IY+12)
        LD E,(IY+11)
        LD H,(IY+13)
        LD L,0
        AND A
        SBC HL,DE
        EX DE,HL
        INC D
        DEC D
        JR Z,LEN1
        ADD HL,DE
LEN1    LD (VARS+6),HL
        PUSH HL
        EX DE,HL
        LD A,(IY+13)
        DEC A
.2      RLCA
        AND 3
        LD L,A
        LD H,0
        CALL #805D,#8063,#8063
        EX DE,HL
        SBC HL,DE
        LD (VARS+8),HL
        INC A
        LD (IX+16),A
        XOR A
        LD (IX+19),A
        INC A
        LD (IX+15),A
        LD H,(IY+15)
        LD L,(IY+14)
        LD (VARS+17),HL
        POP HL
        CALL #80D5,#809C,#809F
TV1     CALL LDPAGE
TV2     HALT
        CALL CLPAGE,PRPAGE
TV3     CALL #8081,#8087
        LD HL,KHELP1
        LD DE,KHELP2
        CALL #808A
        JR TV3

EXIT    CALL #80C9,#811D,#8120
        JP #8099

LDPAGE  CALL #805A
        LD HL,BUFFTX1
        LD E,(IX+17)
        LD A,(IX+15)
        PUSH AF
        DEC A
        ADD A,A,A,A
        ADD A,(IX+18)
        LD D,A
        POP AF
        LD BC,#4000
        CP (IX+16)
        JR NZ,LDP1
        LD BC,(VARS+8)
LDP1    PUSH HL,BC
        LD A,C
        AND A
        JR Z,LDP2
        INC B
LDP2    PUSH HL
        CALL #80AB
        POP HL,BC
        ADD HL,BC
        LD (EOF1+1),HL
        POP HL
        LD DE,BUFFTX2
        PUSH DE
LDP3    CALL FLINE,EOF
        JR NZ,LDP3
        POP HL
        LD (VARS+0),HL
        LD (VARS+4),HL
        LD (VARS+2),DE
        DEC HL
        LD (HL),13
        LD A,(IX+15)
        LD B,(IX+19)
        LD (IX+19),A
        SUB B
        DEC A
        RET Z
        EX DE,HL
        LD B,16
LDP4    PUSH BC
        CALL BCL
        POP BC
        DJNZ LDP4
        LD (VARS+4),HL
        RET

PGUP    LD HL,TV3
        PUSH HL
        LD HL,(VARS+4)
        PUSH HL
        LD B,16
PGUP1   PUSH BC
        CALL BCL
        POP BC
        DJNZ PGUP1
        EX DE,HL
        POP HL
        AND A
        SBC HL,DE
        JR Z,PPAGE
        EX DE,HL
        JR PGDN2

PGDN    LD HL,TV3
        PUSH HL
        LD HL,(VARS+4)
        LD B,16
PGDN1   PUSH BC
        CALL FWL
        POP BC
        DJNZ PGDN1
        CALL CPE
        JR Z,NPAGE
PGDN2   LD (VARS+4),HL
        LD HL,TV2
        EX (SP),HL
        RET

LNUP    LD HL,TV3
        PUSH HL
        LD HL,(VARS+4)
        CALL CPB
        JR Z,PPAGE
        CALL BCL
        PUSH HL
        CALL SCDN
        POP HL
        LD (VARS+4),HL
        LD DE,#4080
        JR LNDN2

LNDN    LD HL,TV3
        PUSH HL
        LD HL,(VARS+4)
        CALL FWL,CPE
        JR Z,NPAGE
        PUSH HL
        LD B,15
LNDN1   PUSH BC
        CALL FWL
        POP BC
        DJNZ LNDN1
        POP DE
        CALL CPE
        JR Z,NPAGE
        LD (VARS+4),DE
        PUSH HL
        CALL SCUP
        POP HL
        LD DE,#5060
LNDN2   LD C,0
        JP PRLINE

PPAGE   LD A,(IX+15)
        DEC A
        RET Z
PPAGE1  LD (IX+15),A
        LD HL,TV1
        EX (SP),HL
        RET

NPAGE   LD A,(IX+15)
        CP (IX+16)
        RET Z
        INC A
        JR PPAGE1

SCUP    LD DE,#4080
        LD B,15
SCUP1   PUSH DE,BC
        LD HL,DE
        CALL IR_HL
        LD BC,#0900
SCUP2   PUSH HL,DE
.32     LDI
        POP DE,HL
        INC D,H
        DJNZ SCUP2
        POP BC,DE
        CALL IR_DE
        DJNZ SCUP1
        LD HL,#5060
        JR SCDN3

SCDN    LD DE,#5060
        LD B,15
SCDN1   PUSH DE,BC
        LD HL,DE
        CALL DR_HL
        LD BC,#0900
SCDN2   PUSH HL,DE
.32     LDI
        POP DE,HL
        INC D,H
        DJNZ SCDN2
        POP BC,DE
        CALL DR_DE
        DJNZ SCDN1
        LD HL,#4080
SCDN3   LD BC,#0800
SCDN4   LD A,L
.31     LD (HL),C:INC L
        LD (HL),C
        LD L,A
        INC H
        DJNZ SCDN4
        RET

DR_HL   LD A,L
        SUB #20
        LD L,A
        RET NC
        LD A,H
        SUB 8
        LD H,A
        RET

IR_HL   LD A,L
        ADD A,#20
        LD L,A
        RET NC
        LD A,H
        ADD A,8
        LD H,A
        RET

DR_DE   LD A,E
        SUB #20
        LD E,A
        RET NC
        LD A,D
        SUB 8
        LD D,A
        RET

IR_DE   LD A,E
        ADD A,#20
        LD E,A
        RET NC
        LD A,D
        ADD A,8
        LD D,A
        RET

PRPAGE  LD HL,(VARS+4)
        LD DE,#4080
        LD BC,#1000
PRPG1   PUSH DE,BC
        CALL PRLINE
        POP BC,DE
        CALL IR_DE
        DJNZ PRPG1
        RET

PRLINE  PUSH HL
        LD HL,PRL1
        EX (SP),HL
PRL0    CALL CPE
        RET Z
        LD A,(HL)
        INC HL
        CP 13
        RET Z
        CALL PRS64
        LD A,C
        AND A
        JR NZ,PRL0
        CALL CPE
        RET Z
        LD A,(HL)
        CP 13
        RET NZ
        INC HL
        RET
PRL1    LD (VARS+10),HL
        LD (VARS+12),DE
        LD (IX+14),C
        RET

CPB     PUSH HL,DE
        LD DE,(VARS)
        AND A
        SBC HL,DE
        POP DE,HL
        RET

CPE     PUSH HL,DE
        LD DE,(VARS+2)
        AND A
        SBC HL,DE
        POP DE,HL
        RET

PRS64   CP 32
        JR Z,PRS64B
        PUSH HL,BC
        LD H,FONT64[
        LD L,A,A,C
        AND 4
        LD BC,#F00F
        JR NZ,PRS64A
        LD BC,#0FF0
PRS64A  LD A,(DE)
        AND B
        LD LY,A
        LD A,(HL)
        AND C
        OR LY
        LD (DE),A
        INC D,H
        LD A,(DE)
        AND B
        LD LY,A
        LD A,(HL)
        AND C
        OR LY
        LD (DE),A
        INC D,H
        LD A,(DE)
        AND B
        LD LY,A
        LD A,(HL)
        AND C
        OR LY
        LD (DE),A
        INC D,H
        LD A,(DE)
        AND B
        LD LY,A
        LD A,(HL)
        AND C
        OR LY
        LD (DE),A
        INC D,H
        LD A,(DE)
        AND B
        LD LY,A
        LD A,(HL)
        AND C
        OR LY
        LD (DE),A
        INC D,H
        LD A,(DE)
        AND B
        LD LY,A
        LD A,(HL)
        AND C
        OR LY
        LD (DE),A
        INC D,H
        LD A,(DE)
        AND B
        LD LY,A
        LD A,(HL)
        AND C
        OR LY
        LD (DE),A
        INC D,H
        LD A,(DE)
        AND B
        LD LY,A
        LD A,(HL)
        AND C
        OR LY
        LD (DE),A
        LD A,D
        SUB 7
        LD D,A
        POP BC,HL
PRS64B  LD A,C
        ADD A,4
        LD C,A
        AND 4
        RET NZ
        INC E
        RET

FWL     CALL CPE
        RET Z
        LD BC,65
        LD A,13
        CPIR
        RET

BCL     CALL CPB
        RET Z
        DEC HL
        CALL CPB
        RET Z
        DEC HL
        LD BC,65
        LD A,13
        CP (HL)
        JR Z,BCL1
        CPDR
        INC HL
BCL1    INC HL
        RET


CLPAGE  LD HL,#4100
        LD DE,0
        LD B,8
CLP1    LD C,1
        CALL CLP4
        DJNZ CLP1
        LD HL,#5000
        LD C,16
        CALL CLP4
        LD HL,#5080
        LD B,8
CLP3    LD C,1
        CALL CLP4
        DJNZ CLP3
        RET
CLP4    LD IY,0
        ADD IY,SP
        LD SP,HL
CLP5
.64     PUSH DE
        DEC C
        JP NZ,CLP5
CLP6    LD SP,IY
        INC H
        RET

FLINE   LD C,0
FL0     CALL EOF
        JR Z,FL4
        LD A,(HL)
        INC HL
        CP 9
        JR Z,FL2
        CP 13
        JR Z,FL4
        LD (DE),A
        INC DE,C
        LD A,C
FL1     CP 64
        JR C,FL0
        CALL EOF
        JR Z,FL4
        LD A,(HL)
        CP 13
        JR NZ,FL4
        INC HL
        JR FL4
FL2     LD A,C
        AND 7
        LD B,A
        LD A,8
        SUB B
        LD B,A
        PUSH AF
        LD A,32
FL3     LD (DE),A
        INC DE
        DJNZ FL3
        POP AF
        ADD A,C
        LD C,A
        JR FL1
FL4     LD A,13
        LD (DE),A
        INC DE
        CALL EOF
        RET Z
        LD A,(HL)
        CP 10
        RET NZ
        INC HL
        RET

EOF     PUSH HL,DE
EOF1    LD DE,0
        AND A
        SBC HL,DE
        POP DE,HL
        RET

KHELP1  DB 14:DW EXIT
        DB 0
KHELP2  DW PGUP,PGDN,LNUP,LNDN,PGUP,PGDN
        DW TV3,TV3

TFNF    DB "textview"
TFNE    DB "fnt"

        ORG #9E00
FONT64  INCB "font64"

BUFFTX1 EQU #C000
BUFFTX2 EQU #B800